diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.c b/xlators/mgmt/glusterd/src/glusterd-utils.c
index f84e8ba4e71..e3ec54b4437 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.c
@@ -669,11 +669,7 @@ glusterd_volinfo_unref(glusterd_volinfo_t *volinfo)
 
     pthread_mutex_lock(&conf->volume_lock);
     {
-        pthread_mutex_lock(&volinfo->reflock);
-        {
-            refcnt = --volinfo->refcnt;
-        }
-        pthread_mutex_unlock(&volinfo->reflock);
+        refcnt = GF_ATOMIC_DEC(volinfo->refcnt);
     }
     pthread_mutex_unlock(&conf->volume_lock);
     if (!refcnt) {
@@ -687,12 +683,7 @@ glusterd_volinfo_unref(glusterd_volinfo_t *volinfo)
 glusterd_volinfo_t *
 glusterd_volinfo_ref(glusterd_volinfo_t *volinfo)
 {
-    pthread_mutex_lock(&volinfo->reflock);
-    {
-        ++volinfo->refcnt;
-    }
-    pthread_mutex_unlock(&volinfo->reflock);
-
+    GF_ATOMIC_INC(volinfo->refcnt);
     return volinfo;
 }
 
@@ -753,7 +744,7 @@ glusterd_volinfo_new(glusterd_volinfo_t **volinfo)
     glusterd_shdsvc_build(&new_volinfo->shd.svc);
 
     pthread_mutex_init(&new_volinfo->store_volinfo_lock, NULL);
-    pthread_mutex_init(&new_volinfo->reflock, NULL);
+    GF_ATOMIC_INIT(new_volinfo->refcnt, 0);
 
     *volinfo = glusterd_volinfo_ref(new_volinfo);
 
@@ -864,6 +855,7 @@ glusterd_volinfo_delete(glusterd_volinfo_t *volinfo)
     int32_t ret = -1;
 
     GF_ASSERT(volinfo);
+    GF_ASSERT(GF_ATOMIC_GET(volinfo->refcnt) == 0);
 
     cds_list_del_init(&volinfo->vol_list);
     cds_list_del_init(&volinfo->snapvol_list);
@@ -894,7 +886,6 @@ glusterd_volinfo_delete(glusterd_volinfo_t *volinfo)
     glusterd_shd_svcproc_cleanup(&volinfo->shd);
 
     pthread_mutex_destroy(&volinfo->store_volinfo_lock);
-    pthread_mutex_destroy(&volinfo->reflock);
     LOCK_DESTROY(&volinfo->lock);
 
     GF_FREE(volinfo);
diff --git a/xlators/mgmt/glusterd/src/glusterd.h b/xlators/mgmt/glusterd/src/glusterd.h
index 5927e000562..e11b4751c6f 100644
--- a/xlators/mgmt/glusterd/src/glusterd.h
+++ b/xlators/mgmt/glusterd/src/glusterd.h
@@ -417,8 +417,7 @@ struct glusterd_volinfo_ {
     int op_version;
     int client_op_version;
     int32_t quota_xattr_version;
-    pthread_mutex_t reflock;
-    int refcnt;
+    gf_atomic_t refcnt;
     gd_quorum_status_t quorum_status;
 
     glusterd_snapdsvc_t snapd;
